#!/bin/bash
clear
check=n
while [ "$check" == "N" -o "$check" == "n" ]; do
	clear
	echo -e "\033[1m---------------------------------------"
	echo -e "Welcome to RConnect Installation Wizard "
	echo -e "---------------------------------------"
	pc=1
	echo -e "\n[STEP : $pc ] Select your Reliance IndiaMobile\n \033[0m"
	echo -e "\033[1mSelect make of your phone\033[0m\n"
	let pc++
	user=$USER
	if [ "$user" != "root" ]
	then	
	echo -e "Only root user can install \nLogin as username-->root then try installation again"
	echo -e "RConnect Installation terminated"
	exit
	fi

	currentdir=`pwd`
	CHECK=0
	if [ ! -e $currentdir/common/sheller.sh ]
	then
		echo "File sheller.sh missing in your package"
		CHECK=1
	fi
	if [ ! -e $currentdir/common/options ]
	then
		echo "File options missing in your package"
		CHECK=1
	fi
	if [ ! -e $currentdir/common/rconnect ]
	then
		echo "File rconnect missing in your package"
		CHECK=1
	fi 
	if [ ! -e $currentdir/common/rdisconnect ]
	then
		echo "File rdisconnect missing in your package"
		CHECK=1
	fi
	if [ ! -e $currentdir/common/check ]
	then
		echo "File check missing in your package"
		CHECK=1
	fi
	if [ ! -e $currentdir/common/runinstall ]
	then
		echo "File runinstall missing in your package"
		CHECK=1
	fi
	if [ $CHECK -eq 1 ]
	then
		echo "File required for installation might be missing in your package"
		echo "RConnect Installation terminated"
		exit
	fi

	array=(`ls $currentdir/phones -1`)
	arraylen=${#array[*]}
	i=0
	j=1
	while [ $i -lt $arraylen ]; do
	
		if [ $j -gt 9 ]
		then
			echo -e "$j. ${array[$i]}" | tr "_" " " 
		else
			echo -e " $j. ${array[$i]}" | tr "_" " "
		fi
		let i++
		let j++
	done
	printf "\nTo choose Your phone just type the corresponding serial number : "
	read  makech

	#-------validate the serial number-------
	while [ $makech -lt 1 -o $makech -gt $arraylen ]
	do
		printf "\nInvalid serial number! Please Re-enter the Serial number : "
		read  makech
	done
	if [ $makech -gt 0 -o $makech -le $arraylen ]
	then 
		printf "\nSelected make of your phone : ${array[`expr $makech - 1`]//_/ }" 
		printf "\nHave you selected the correct make of your phone (Y/N) : "
		read -n 1 check
		check=`echo $check | tr [A-Z] [a-z]`
	fi

	if [ "$check" == 'y' ]
	then
		break
	fi

	while [ "$check" != 'n' -o "$check" != 'y' ]; do
		if [ "$check" == 'n' -o "$check" == 'y' ]
		then
			break
		fi
		printf "\nHave you selected the correct phone (Y/N) : "
		read -n 1 check
		check=`echo $check | tr [A-Z] [a-z]`
	done
done
################For model###############################################################
modelcheck=n
while [ "$modelcheck" == "N" -o "$modelcheck" == "n" ]; do
	clear
        echo -e "\033[1m---------------------------------------"
        echo -e "Welcome to RConnect Installation Wizard "
        echo -e "---------------------------------------"
        echo -e "\n[STEP : $pc ] Select your Reliance IndiaMobile \033[0m"
        let pc++
	echo -e "\n\033[1mSelect Model of your phone\033[0m\n"
	if [ "$check" == 'y' ]
	then
		modelarray=(`ls $currentdir/phones/${array[$makech - 1]}  -1`)
        	modelarraylen=${#modelarray[*]}
        	i=0
        	j=1
        	while [ $i -lt $modelarraylen ]; do

                	if [ $j -gt 9 ]
                	then
                        	echo -e "$j. ${modelarray[$i]}" | tr "_" " "
               	 	else
                        	echo -e " $j. ${modelarray[$i]}" | tr "_" " "
                	fi
               		 let i++
                	let j++
        	done
        	printf "\nTo choose Your model just type the corresponding serial number : "
        	read  modelch

        	#-------validate the serial number-------
        	while [ $modelch -lt 1 -o $modelch -gt $modelarraylen ]
        	do
                	printf "\nInvalid serial number! Please Re-enter the Serial number : "
                	read  modelch
        	done
        	if [ $modelch -gt 0 -o $modelch -le $modelarraylen ]
        	then
                	printf "\nSelected model : ${modelarray[`expr $modelch - 1`]//_/ }"
                	printf "\nHave you selected the correct model (Y/N) : "
                	read -n 1 modelcheck
                	modelcheck=`echo $modelcheck | tr [A-Z] [a-z]`
        	fi

        	if [ "$modelcheck" == 'y' ]
        	then
                	break
        	fi

        	while [ "$modelcheck" != 'n' -o "$modelcheck" != 'y' ]; do
                	if [ "$modelcheck" == 'n' -o "$modelcheck" == 'y' ]
                	then
                        	break
                	fi
                	printf "\nHave you selected the correct model (Y/N) : "
                	read -n 1 modelcheck
                	check=`echo $modelcheck | tr [A-Z] [a-z]`
        	done
	fi
done

########################################################################################		


k=0
COMFOUND=1 #for sub directory
USBFOUND=1 
if [ "$check" == "y" -o "$check" == "Y" ]
then
#-------------copy the common files-------------
	sh $currentdir/common/sheller.sh >/dev/null
	cp $currentdir/common/options /etc/ppp/options 
	cp $currentdir/common/a.ppprc $HOME/.ppprc
	cp $currentdir/common/rconnect /sbin/rconnect
	cp $currentdir/common/rdisconnect /sbin/rdisconnect
	cp $currentdir/common/rupdate /sbin/rupdate
	if [ ! -e "/etc/rconnect" ]
	then
		`mkdir /etc/rconnect`
	fi
	cp $currentdir/common/check /etc/rconnect/check
	cp $currentdir/common/monitor /etc/rconnect/monitor
	cp $currentdir/common/detectmodem /etc/rconnect/detectmodem
	chmod 755 /sbin/rdisconnect
	#chmod 755 /sbin/runinstall

	currentdir2=$currentdir/phones/${array[$makech - 1]}/${modelarray[$modelch - 1]}
	subarray=(`ls $currentdir/phones/${array[$makech -1]}/${modelarray[$modelch - 1]}`)
	subarraylen=${#subarray[*]}
	len=`expr length ${modelarray[$modelch - 1]}`
	while [ $k -lt $subarraylen ]; do
		subtemp=${subarray[$k]}	 
		temp=${subtemp:$len}
		if [ "$temp" == "_COM" ] #check com folder is present
		then			
			comdir=$currentdir/phones/${array[makech - 1]}/${modelarray[$modelch - 1]}/${subarray[$k]}
			comfile=${subarray[$k]}
			COMFOUND=0
		fi
		if [ "$temp" == "_USB" ] #check usb folder is present
		then			
			usbdir=$currentdir/phones/${array[$makech - 1]}/${modelarray[$modelch - 1]}/${subarray[$k]}
			usbfile=${subarray[$k]}
			USBFOUND=0
		fi
		let k++
	done
	if [ "$COMFOUND" == "0" -a "$USBFOUND" == "0" ]
	then
		clear
		echo -e "\033[1m---------------------------------------"
		echo -e "Welcome to RConnect installation Wizard "
		echo -e "---------------------------------------"
		echo -e "\n[STEP : $pc ] Select the data cable type\n\033[0m"
		let pc++
		echo -e "(S) SERIAL Cable"
		echo -e "(U) USB Cable"
		echo 
		printf "\nSelect your cable type (U/S) : "
		read -n 1 cablech
		cablech=`echo $cablech | tr [A-Z] [a-z]`
        	while [ "$cablech" != 'u' -o "$cablech" != 's' ]; do
	        	if [ "$cablech" == 'u' -o "$cablech" == 's' ]
	        	then
		        	break
	        	fi
	            	printf "\nInvalid Entry!! Please select your cable type (U/S) : "
	        	read -n 1  cablech
			cablech=`echo $cablech | tr [A-Z] [a-z]`
        	done
		if [ "$cablech" == "u" -o "$cablech" == "U" ]
		then
			finalpath=$usbdir/$usbfile
			$currentdir/usbwizard $usbfile $finalpath $pc
			
		fi	
		if [ "$cablech" == "s" -o "$cablech" == "S" ]
		then
			finalpath=$comdir/$comfile
			$currentdir/comwizard $comfile $finalpath $pc
		fi
	
	else
		if [ "$COMFOUND" == "0" ]
		then
			finalpath=$comdir/$comfile
			$currentdir/comwizard $comfile $finalpath $pc
		fi
		if [ "$USBFOUND" == "0" ]
		then
			finalpath=$usbdir/$usbfile
			$currentdir/usbwizard $usbfile $finalpath $pc
		fi
	fi		
fi

exit 0

	
 

